TITLE Callint the AddAll function     (addall.asm)

INCLUDE Irvine32.inc

; "NEAR C" qualifier is required when using VARARG.

AddAll PROTO NEAR C, argcount:DWORD, vals:VARARG

.code
main PROC

	INVOKE AddAll, 3, 10h, 15h, 20h
	call DumpRegs

	exit
main ENDP

AddAll PROC NEAR C, argcount:DWORD, vals:VARARG
	push esi
	mov eax,0	; clear the sum
	mov esi,0	; initialize index register

	.WHILE  argcount > 0	; number of arguments
	  add  eax,vals[esi]	; vals is the first argument
	  dec  argcount	; point to next argument
	  add  esi,TYPE DWORD
	.ENDW

	pop esi
	ret	; EAX contains the sum
AddAll  ENDP

END main